;  $Id: DEVCON.ASM 1.8 2003/03/20 17:04:10 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1988-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DEVCON.ASM  created 10/08/88  by Drew Gislason

   Copyright (c) 1988-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains the internal (built-in) console
   device driver for ROM-DOS.  The device has a name of
   "CON".  You've all seen it before.

---------------------------------------------------------- ~
include macros.inc
include devhdr.inc
include profile.inc

; make the device accessible to SYSGEN.ASM
PUBLIC	_conx

; If true, allow ROM-DOS to use extended keyboard functions
; on those BIOSes that support it.
EXTENDED equ	1

; If true, include the flush function.  ROM-DOS doesn't use
; the flush function, so no need to implement it.
FLUSH    equ	0

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	BIOS RESOURCES USED
;
;	This area defines all the BIOS calls that this
;	device driver makes.

BIOSVID		EQU 10H	; BIOS video interrupt
BIOSKEY		EQU 16H	; BIOS keyboard interrupt

BIOSVID_TTY	EQU 0EH	; display a character
BIOSKEY_GET	EQU 0	; get a key
BIOSKEY_CHK	EQU 1	; is key available?
BIOSKEY_SHSTAT	EQU 2	; check shift status
BIOSKEY_GET2	EQU 10H	; get a key
BIOSKEY_CHK2	EQU 11H	; is key available?

cBegCode
	EXTRN	dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near

cmdtbl:
	DW	con_init	; 0 - INIT
	DW	dev_cmd_err	; 1 - (reserved for block devices)
	DW	dev_cmd_err	; 2 - 		""
	DW	dev_cmd_err	; 3 - ioctl (not enabled)
	DW	con_read	; 4 - read (1 character only!!!)
	DW	con_ndread	; 5 - non-destructive read
	DW	dev_cmd_err	; 6 - status
IF FLUSH
	DW	con_rdflush	; 7 - rd flush
ELSE
	DW	dev_cmd_err	; 7 - rd flush
ENDIF
	DW	con_write	; 8 - write (1 character only!!!)
cmdend:

cEndCode

cBegData
	EXTRN	_ptrsav:DWORD
	getkey	db	BIOSKEY_GET
	chkkey	db	BIOSKEY_CHK
cEndData

_DEVDATA segment byte public 'DEVDATA'

	ASSUME CS:_DEVDATA ,DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD

_conx:
	DW	-1,-1		; the console device
	DW	8013H
	DW	dev_fstrat
	DW	con_serv
	DB	"CON     ",0

	public	con_serv
con_serv:
	push	AX
	push	SI

	; calc # of commands and where to find cmdtbl
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET cmdtbl

	; jump to the generic service routine in ROM (CODE SEG)
	jmp	DWORD PTR CS:[cmd_ptr]

_DEVDATA ENDS


cBegUdata
	extrn	con_que:byte	; is anything queued?
	extrn	con_byte:byte	; the value of the byte
cEndUdata


cBegCode


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	DS	= DGROUP
;	CX	= count
;	ES:[DI] = transfer area

	public con_read
con_read:

	ENTER_FUNCTION

	cmp	[con_que], 0
	jz	rd_bios
	mov	AL, [con_byte]	; get the next byte from the que
	mov	[con_que], 0
	jmp	short L1

rd_bios:
	mov	AH, [getkey]
	int	BIOSKEY
IF EXTENDED
	; cursor keys on "middle" pad have E0H as databyte
	cmp	AL, 0E0H
	jnz	conrd0
	cmp	AH, 0
	jz	conrd0		; 00E0H is a key, xxE0H is cursor
	xor	AL, AL		; zero lower byte to show this is cursor
conrd0:
ENDIF
	cmp	AL, 0
	jnz	L1
	mov	con_que, 1	; que up the scan code
	mov	con_byte, AH
L1:	mov	ES:[DI], AL

	EXIT_FUNCTION

	jmp	dev_exit


	public	con_ndread
con_ndread:

	ENTER_FUNCTION

	cmp	[con_que], 0
	jz	bios_ndread
	mov	AL, [con_byte]	; get the next byte from the que
	jmp	short L2
bios_ndread:
	mov	AH, [chkkey]	; is a key available? (ZF means no)
	int	BIOSKEY
	jz	L3		; no characters, go on

	; pull ctrl-breaks from the queue
	or	AX, AX		; if the char is 0000H, it's a ctrl-break
	jnz	L2
	mov	AH, [getkey]	; pull the ctrl-break from the queue
	int	BIOSKEY
	jmp	con_ndread	; go again

L2:	lds	BX, [_ptrsav]	; we have a character
	mov	[BX+MEDIA], AL

	EXIT_FUNCTION

	jmp	dev_exit	; chars
L3:
	EXIT_FUNCTION

	jmp	dev_busy_exit	; no chars


IF FLUSH
	public	con_rdflush
con_rdflush:

	ENTER_FUNCTION

	mov	con_que, 0	; unqueue the byte (if any)
L8:	mov	AH, [chkkey]
	int	BIOSKEY		; is char available?
	jz	L9
	mov	AH, [getkey]
	int	BIOSKEY		; toss out next char
	jmp	L8
L9:
	EXIT_FUNCTION

	jmp	dev_exit
ENDIF

	public	con_write
con_write:

	ENTER_FUNCTION

con_w1:	jcxz	con_w2
	mov	BH, 0
	mov	AL, ES:[DI]
	mov	AH, BIOSVID_TTY
	int	BIOSVID
	inc	DI
	dec	CX
	jmp	con_w1
con_w2:
	EXIT_FUNCTION

	jmp	dev_exit

	; determine if we have an extended keyboard or not
	public	con_init
con_init:

	ENTER_FUNCTION

IF EXTENDED
	; ask BIOS if extended keyboard is present
	mov	AX, 40H
	mov	ES, AX
	test	byte ptr ES:[96H], 10H	; is extended keyboard present?
	jz	no_extended

	; clear the zero flag and check for key
	mov	AX, BIOSKEY_CHK2 * 100H
	cmp	AH, BIOSKEY_CHK2+1	; clear zero flag
	int	BIOSKEY
	jz	is_extended	; if BIOS says no char, believe it
	or	AL, AL
	jz	no_extended	; if char, and char==0, don't believe it

	; use extended keyboard functions 10H, 11H
is_extended:
	mov	[getkey], BIOSKEY_GET2
	mov	[chkkey], BIOSKEY_CHK2

	; not an extended keyboard, use old functions
no_extended:
ENDIF
	EXIT_FUNCTION

	jmp	dev_exit

;-------------------------------------------------------
;  Disable the extended keyboard usage.  This is
;  used by the SWITCHES command in CONFIG.SYS.
COMMENT ~ ; prototype ;
void disable_extended(void)
{}
~
c_func	disable_extended

	ENTER_FUNCTION

	mov	[getkey], BIOSKEY_GET
	mov	[chkkey], BIOSKEY_CHK

	EXIT_FUNCTION

	ret
c_endp	disable_extended

;-------------------------------------------------------
;  Get a key from the BIOS.  Some routines need quick
;  access to keystrokes without having to set up a device.
COMMENT ~ ; prototype ;
int con_chkkey(void)
int con_getkey(void)
~
c_func	con_chkkey

	ENTER_FUNCTION

	mov	AH, chkkey
	int	BIOSKEY
	jz	nokey
	public	_con_getkey
_con_getkey:
	mov	AH, getkey
	int	BIOSKEY

	EXIT_FUNCTION

	ret
nokey:	mov	AX, -1

	EXIT_FUNCTION

	ret
c_endp	con_chkkey

c_func	con_shstat

	ENTER_FUNCTION

	mov	AH, BIOSKEY_SHSTAT
	int	BIOSKEY

	EXIT_FUNCTION

	ret
c_endp	con_shstat

;-------------------------------------------------------
;  Display a character to the screen, quickly
;
;  The generic interrupt handlers install this routine
;
c_func	int_29

	ENTER_FUNCTION

	push	BP
	push	SI
	push	DI
	push	BX
	push	AX

	; display the character (in AL) to the screen
	mov	AH, BIOSVID_TTY
	mov	BX, 7
	int	BIOSVID

	pop	AX
	pop	BX
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	iret
c_endp	int_29

cEndCode
	END
