;  $Id: DEVNUL.ASM 1.8 2003/03/20 17:05:42 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1989-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DEVNUL.ASM  created 03/08/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains both the "NUL" device driver as well
   as the code for the memory size.  Always include this
   driver (or an equivalent one) in ROM-DOS.

   The memory size function, while not part of the device
   driver is included here so that the source of it is
   available to a purchaser of the ROM-DOS Developer's Kit.

---------------------------------------------------------- ~
include macros.inc
include devhdr.inc
include profile.inc

EXTRN	_nulx:near



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	DEVICE HEADER
;
cBegCode
	EXTRN	dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;
	; Due to some internal quirks, the NUL device init
	; routine will never be called.  See DOSMAIN.C for
	; details.
	;
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmdtbl:
	dw	dev_exit	; 0  - INIT
	dw	dev_cmd_err	; 1  - MEDIA CHK (reserved for block devs)
	dw	dev_cmd_err	; 2  - BUILD BPB	""
	dw	dev_cmd_err	; 3  - IOCTL INPUT (not enabled)
	dw	nul_read	; 4  - READ
	dw	dev_exit	; 5  - NON_DESTRUCTIVE READ (always chars)
	dw	dev_cmd_err	; 6  - INPUT STATUS
	dw	dev_cmd_err	; 7  - INPUT FLUSH
	dw	dev_exit	; 8  - WRITE
cmdend:

cEndCode

_DEVDATA segment byte public 'DEVDATA'

	ASSUME CS:_DEVDATA ,DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD

	public	nul_serv
nul_serv:
	push	AX
	push	SI

	; calc # of commands and where to find cmdtbl
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET cmdtbl

	; Jump to the REAL service routine in ROM (CODE SEG)
	jmp	DWORD PTR CS:cmd_ptr
_DEVDATA ENDS


cBegData
	EXTRN	_ptrsav:dword, _ROM_DEVSEG:word

	tmp	dw	?

	;--------------------------------------------------
	;
	; The NUL device driver header MUST follow the List
	; of Lists.  That puts it in DGROUP.  All other
	; device driver headers must be in the _DEVDATA
	; segment.  Hence we have special strategy and
	; service routines for the NUL device.  All other
	; devices go through common routines.
	;
	;--------------------------------------------------
	ASSUME CS:DGROUP

	public nuld_strat, nuld_serv
nuld_strat:

	ENTER_FUNCTION

	push	[_ROM_DEVSEG]
	mov	[tmp], OFFSET _DEVDATA:dev_fstrat
	push	[tmp]

	EXIT_FUNCTION

	retf

nuld_serv:

	ENTER_FUNCTION

	push	[_ROM_DEVSEG]
	mov	[tmp], OFFSET _DEVDATA:nul_serv
	push	[tmp]

	EXIT_FUNCTION

	retf

cEndData

cBegCode

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; NUL read (return 0 bytes)
;
nul_read:

	ENTER_FUNCTION

	mov	byte ptr ES:[DI], 26	; always "read" a ^Z
	lds	BX, [_ptrsav]
	mov	word ptr [BX+COUNT], 0

	EXIT_FUNCTION

	jmp	dev_exit
cEndCode

	END
