;  $Id: DEVPRN.ASM 1.8 2003/03/20 17:05:58 thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1989-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DEVPRN.ASM  created 05/11/89  by Drew Gislason
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains the printer device, called "PRN",
   and the device names "LPT1" - "LPT4".

---------------------------------------------------------- ~
include macros.inc
include devhdr.inc
include profile.inc

PUBLIC	_prnx

; BIOS interrupts used
BIOSPRN		EQU 17H
BIOSEQUIP	EQU 11H

;----------------------------------------------------------------------
;
;		The Device Header
;
cBegCode
	EXTRN	dev_serv:NEAR

cmdtbl:
	DW	prn_init	; 00 - INIT
	DW	dev_cmd_err	; 01 - MEDIA CHK (reserved for block devs)
	DW	dev_cmd_err	; 02 - BUILD BPB	""
	DW	dev_exit	; 03 - IOCTL INPUT (not enabled)
	DW	dev_cmd_err	; 04 - READ
	DW	dev_busy_exit	; 5  - NON_DESTRUCTIVE READ (no chars ever)
	DW	dev_cmd_err	; 06 - INPUT STATUS
	DW	dev_cmd_err	; 07 - INPUT FLUSH
	DW	prn_write	; 08 - WRITE
	DW	prn_write	; 09 - WRITE W/ VERIFY
	DW	dev_cmd_err	; 0A - OUTPUT STATUS
	DW	dev_cmd_err	; 0B - FLUSH OUTPUT
	DW	dev_cmd_err	; 0C - IOCTL WRITE
	DW	dev_exit	; 0D - OPEN
	DW	dev_exit	; 0E - CLOSE
cmdend:

cEndCode

cBegData
cEndData

_DEVDATA segment byte public 'DEVDATA'

	ASSUME CS:_DEVDATA ,DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD
	EXTRN	nul_serv:NEAR
	extrn	dev_dgroup:word

_prnx:
	DW	offset _lpt1,-1
	DW	8040H
	DW	offset dev_fstrat
	DW	offset prn_serv1
	DB	"PRN     ",0,0

; total header length is 20 bytes
DEV_HDR_LEN equ 20
; service offset in header is at byte 8
SERV_OFF equ 8

_lpt1:
	DW	offset _lpt2,-1		; 00H
	DW	8040H			; 04H
	DW	offset dev_fstrat	; 06H
	DW	offset nul_serv		; 08H
	DB	"LPT1    ",0,0		; 0AH

_lpt2:
	DW	offset _lpt3,-1
	DW	8040H
	DW	offset dev_fstrat
	DW	offset nul_serv
	DB	"LPT2    ",0,1

_lpt3:
	DW	-1, -1
	DW	8040H
	DW	offset dev_fstrat
	DW	offset nul_serv
	DB	"LPT3    ",0,2

; each 5 byte service routine gets PRN port, then jumps to real service
SERV_HDR_LEN equ 5

prn_serv3:
	push	AX
	mov	AL, 2
	jmp	short prn_serve
prn_serv2:
	push	AX
	mov	AL, 1
	jmp	short prn_serve
prn_serv1:
	push	AX
	mov	AL, 0
prn_serve:
	push	SI

	; set the port #, so common printer routines can use it
	push	DS
	mov	DS, CS:[dev_dgroup]
	ASSUME DS:DGROUP
	mov	prnport, AL
	ASSUME DS:_DEVDATA
	pop	DS

	; calc # of commands and where to find cmdtbl
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET cmdtbl

	; Jump to the REAL service routine in ROM (CODE SEG)
	jmp	DWORD PTR CS:[cmd_ptr]
_DEVDATA ENDS

cBegUdata
	extrn	prnport:byte
	extrn	prninit:byte
cEndUdata


;---------------------------------------------------------
;	CODE
;

cBegCode
	EXTRN	dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near

	c_extrn	getDEVDATA,near

IF 0
;---------------------------------------------------------
;
;	FUNCTION 10  -  OUTPUT STATUS
;
prn_outstat:

	ENTER_FUNCTION

	; get status of printer
	mov	AH, 2
	xor	DX, DX
	mov	DL, prnport
	int	BIOSPRN

	; test for printer busy
	test	AH, 80H
	jnz	stat_ok

	EXIT_FUNCTION

	jmp	dev_busy_exit
stat_ok:
	EXIT_FUNCTION

	jmp	dev_exit
ENDIF


;---------------------------------------------------------
;
;	FUNCTION 8/9  -  WRITE (VERIFY IGNORED)
;
;	DS    = DGROUP
;	ES:DI = transfer area
;	CX    = count
;
IOERR	EQU	28H
PAPERR	EQU	20H

	public prn_write
prn_write:

	ENTER_FUNCTION

	mov	AH, 2		; test for error before we write
	xor	DX, DX
	mov	DL, prnport
	int	BIOSPRN
	test	AH, IOERR	; some printer error
	jz	writex
	test	AH, PAPERR	; No paper error?
	jz	no_prn
	mov	AL, ERR_NOPAPER

	EXIT_FUNCTION

	jmp	dev_err_exit
no_prn:
	mov	AL, ERR_WRITEFAULT

	EXIT_FUNCTION

	jmp	dev_err_exit

writex:
	mov	AL, ES:[DI]	; get character
	mov	AH, 0
	xor	DX, DX
	mov	DL, prnport
	int	BIOSPRN

	test	AH, IOERR
	jz	W1

	EXIT_FUNCTION

	jmp	dev_err_exit	; some printer error

W1:	inc	di
	loop	writex

	EXIT_FUNCTION

	jmp	dev_exit

;---------------------------------------------------------
;
;		FUNCTION 0  -  INIT DEVICE
;
;	DS    = DGROUP
;	ES:DI = transfer area
;	CX    = count
;
	public	prn_init
prn_init:

	ENTER_FUNCTION

	; don't initialize twice
	cmp	prninit, 0
	jnz	done
	inc	prninit

	; determine # of PRINTER ports
	int	BIOSEQUIP	; Equipment list (PRN ports in bits 14-15)
	mov	CL, 14
	shr	AX, CL
	mov	CX, AX

	; no printer ports
	jcxz	done

	; link in each printer port (LPT1-LPT3, change service from nul)
	mov	CX, 3
init0:	push	CX
	push	DS

	assume	DS:_DEVDATA
	call	getDEVDATA
	mov	DS, AX

	mov	AX, OFFSET _DEVDATA:prn_serv1
	mov	SI, OFFSET _DEVDATA:_lpt1 + SERV_OFF

init1:	mov	WORD PTR [SI], AX
	add	SI, DEV_HDR_LEN
	sub	AX, SERV_HDR_LEN
	loop	init1

	assume	DS:DGROUP

	pop	DS
	pop	CX

	; initialize each printer port
init3:	jcxz	done
	mov	AH, 1
	dec	CX
	mov	DX, CX
	int	BIOSPRN
	jmp	init3

done:
	EXIT_FUNCTION

	jmp	dev_exit

cEndCode

	END
