//
//   $Id: CPP.CPP 1.2 2002/10/16 15:58:32 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 *  RXE-Test Program.  Used to test RXEability of code and Library
 *  for a given compiler.  This program is for Datalight internal
 *  use only.  It was taken from a demo C_thru_ROM program.
 *  It should compile corectly with either Borland C or Microsoft C.
 *
 *  Problems found to date:
 *
 *		1) Borland-C
 *			Startup Code saves DGROUP in TEXT segment
 *			malloc in large model
 *			Floating Point Package is not ROMable
 *
 *		2) Microsoft C
 *			Startup Code saves DGROUP in TEXT segment
 *			Floating Point Package is not ROMable
 *
 */

#ifdef __cplusplus
extern "C" {
#endif

/*
	BORLAND/TURBO C/C++ MACROS
*/
#ifdef __TURBOC__

	#define	enable()					_enable()
	#define	disable()				_disable()
	#define	setvect(intnum,isr)	_dos_setvect(intnum,isr)
	#define	getvect(intnum)		_dos_getvect(intnum)
#endif

/* inline functions */
#define NULL	0
#define MK_FP(seg,off) \
	((void far *)(((unsigned long)(seg)<<16) | (unsigned)(off)))
#define FP_SEG(farptr)	((unsigned)((unsigned long)(farptr) >> 16))
#define FP_OFF(farptr)	((unsigned)(farptr))
#define assert(expr) if(expr) _assert("expr",__FILE__,__LINE__)
#define puts(s)		_puts(s)
#define putchar(c)	_putchar(c)

/* prototypes for standard library functions */
void * calloc(unsigned items, unsigned size);
void _disable(void);
void (interrupt far * _dos_getvect(int intnum))();
void _dos_setvect(int intnum, void (interrupt far *isr)());
void _enable(void);
void far_free(void far * id);
void far * far_malloc(unsigned long bytes);
void  free(void * id);
int   inp(unsigned portid);
unsigned  inpw(unsigned portid);
void  outp(unsigned portit, int byte);
void  outpw(unsigned portit, unsigned word);
void *  malloc(unsigned);
int  printf(const char  *__format, ...);
int  puts(char *s);
int  putchar(char c);
int  sprintf(char * buffer, const char *format, ...);

/* prototypes for C_thru_ROM unique functions */
unsigned  getDS(void);
unsigned  getCS(void);

#ifdef  __cplusplus
}
#endif


// One point on the graph
class POINT
{
	// to simplify the example, all members are public
	public:
	int	x;
	int	y;

	// point functions
	POINT(void);						// default constructor
	POINT(int x_val, int y_val);	// initialized constructor
	~POINT(void);						// destructor
	int Compare(POINT &that);		// point comparisons
	void DisplayVal(void);			// display the value of this point
};

/*
	The default constructor - point this POINT to 0.
*/
POINT::POINT(void)
{
	x = y = 0;
	DisplayVal();
}

/*
	The initialized constructor - point this POINT somewhere.
*/
POINT::POINT(int x_val, int y_val)
{
	x = x_val;
	y = y_val;
	DisplayVal();
}

/*
	The destructor - doesn't have a job in this example.
*/
POINT::~POINT(void)
{
	printf("point at %d:%d removed\n",x,y);
}

/*
	Display this point in a meaningful way.
*/
void POINT::DisplayVal(void)
{
	printf("point set at %d:%d\n",x,y);
}

/*
	Compare "this" point with "that" point.  A reference is
	used simply to conserve stack space in case POINT is a
	large object.

	Returns <0 if this is less than that, 0 if the same, >0
	if this is greater.
*/
int POINT::Compare(POINT &that)
{
	int big1, small1;
	int big2, small2;

	// determine the larger and smaller offsets of this point
	if(x > y)
		big1 = x, small1 = y;
	else
		big1 = y, small1 = x;

	// determine the larger and smaller offsets of that point
	if(that.x > that.y)
		big2 = that.x, small2 = that.y;
	else
		big2 = that.y, small2 = that.x;

	// this is greater than that
	if(big1 > big2)
		return 1;

	// this may be equal to that
	else if(big1 == big2)
	{
		// this is greater than that
		if(small1 > small2)
			return 1;

		// this is equal to that
		else if(small1 == small2)
			return 0;

		// this is smaller than that
		else
			return -1;
	}

	// this is smaller than that
	else
		return -1;
}

// declare some global POINTs
POINT firstPoint;
POINT nextPoint(5,4);

// in C++, we must declare a function before we can use it
int comparex(int x1, int x2);
char * compareName(int compval);

void main(void)
{
	int val;

	printf("C++ example - we should have seen some global points\n");

	// compare the first point with the next
	firstPoint.Compare(nextPoint);

	// create some local POINTs on the heap using new
	POINT * newPointPtr = new POINT;
	POINT * samePointPtr= new POINT(4,5);

	// how do they compare?
	val = samePointPtr->Compare(nextPoint);
	printf("nextPoint is %s samePoint\n",compareName(val));

	// destruct the POINTs we just created
	delete samePointPtr;
	delete newPointPtr;

	// compare to integers
	printf("5 is %s 7\n", compareName(comparex(5,7)));

}

/*
	Compare two integers, return 0 if equal
*/
int comparex(int x1, int x2)
{
	// create some local point on the stack
	POINT pt1(x1,0);
	POINT pt2(x2,0);

	return pt1.Compare(pt2);
}

/*
	Give a name to a comparison
*/
char * compareName(int compval)
{
	if(compval < 0)
		return "less than";
	else if(compval == 0)
		return "equal to";
	else return "greater than";
}
