//  $Id: API.H 1.7 2003/09/06 00:27:50 johnb Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***   
//
//  Copyright (c) 1999-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/* API.H
	API definitions
*/

// 2002-12-30 gvn DJGPP compatible, TCB and other updates
// 2002-02-12 gvn add entries to tcpstat

#ifndef __WIN_TYPES
#define __WIN_TYPES
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#define API_INT		0x7f

#define API_NOOP			0	/* just keep INET alive */
#define API_SENDPING		1	/* send an ICMP echo request */
#define API_GETPING		2	/* get an ICMP echo request */
#define API_STARTMAIL	3	/* start the mail sender (client) */
#define API_GETIPADR		4	/* get an IP address, given a name */
#define API_TCPOPEN		5	/* open a TCP connection */
#define API_TCPREAD		6	/* read from a TCP connection */
#define API_TCPWRITE		7	/* write to a TCP connection */
#define API_TCPCLOSE		8	/* close a TCP connection */
#define API_TCPRESET		9	/* reset a TCP connection */
#define API_TCPDELET		10	/* delete TCP connection resources */
#define API_UDPOPEN		11	/* open a udp socket to receive dg's */
#define API_UDPREAD		12	/* read a udp datagram */
#define API_UDPWRITE		13	/* write a udp datagram */
#define API_UDPCLOSE		14	/* close a udp socket */
#define API_GETVARPTR	15	/* get pointer to variables */
#define API_GETKEY		16	/* get key from INET */
#define API_FILTER		17	// modify source route filter
#define API_TIMERCREATE	18	// create a timer
#define API_TIMERSET    19	// set a timer
#define API_TIMERSTART	20	// start a timer
#define API_TIMERSTOP	21	// stop a timer
#define API_TIMERDELETE	22	// delete a timer

/* Error return code */
#define NONE			0	/* No error */
#define CON_EXISTS	1	/* Connection already exists */
#define NO_CONN		2	/* Connection does not exist */
#define CON_CLOS		3	/* Connection closing */
#define NO_SPACE		4	/* No memory for TCB creation */
#define WOULDBLK		5	/* Would block */
#define NOPROTO		6	/* Protocol or mode not supported */
#define INVALID		7	/* Invalid arguments */
#define BUFSHORT		8	/* Buffer too short for data */
#define RE_ENTER		27	/* Re-entry of Inet */
#define NO_API			50	// API not loaded

/* Mode for the API_TCPOPEN call */
#define	TCP_PASSIVE	0
#define	TCP_ACTIVE	1
#define	TCP_SERVER	2	/* Passive, clone on opening */

/* Socket structure */
#ifndef SOCKET_DEF
#define SOCKET_DEF
typedef struct isocket {
	DWORD dwAddress	__ATTR__;		/* IP address */
	WORD wPort			__ATTR__;		/* port number */
} ISOCKET;

/* Connection structure (two sockets) */
typedef struct connection {
	ISOCKET sLocal	__ATTR__;
	ISOCKET sRemote	__ATTR__;
} CONNECTION;
#endif

#ifndef TIMER_DEF
#define TIMER_DEF
typedef struct timer {
	WORD wNext			__ATTR__;	// struct timer __near *next;
	WORD wPrevious		__ATTR__;	// struct timer __near *prev;
	DWORD start			__ATTR__;	/* Period of counter (load value) */
	DWORD count			__ATTR__;	/* Ticks to go until expiration */
	void (D_FAR *func)()	__ATTR__;/* Function to call at expiration */
	WORD wArg			__ATTR__;	// char __near *arg;		/* Arg to pass function */
	char state			__ATTR__;	/* Timer state */
} TIMER;
#endif

/* IP statistics */
#ifndef IP_STAT_DEF
#define IP_STAT_DEF
struct ip_stats {
	DWORD dwTotal	__ATTR__;	/* Total packets received */
	WORD wRunt		__ATTR__;	/* Smaller than minimum size */
	WORD wLength	__ATTR__;	/* IP header length field too small */
	WORD wVersion	__ATTR__;	/* Wrong IP version */
	WORD wChecksum	__ATTR__;	/* IP header checksum errors */
	WORD wBadproto	__ATTR__;	/* Unsupported protocol */
};
#endif

/* TCP statistics and status variables */
#define	NTCB	19
#ifndef TCP_STAT_DEF
#define TCP_STAT_DEF
struct tcp_stat {
	WORD runt			__ATTR__;	/* Smaller than minimum size */
	WORD checksum		__ATTR__;	/* TCP header checksum errors */
	WORD conout			__ATTR__;	/* Outgoing connection attempts */
	WORD conin			__ATTR__;	/* Incoming connection attempts */
	WORD resets			__ATTR__;	/* Resets generated */
	WORD bdcsts			__ATTR__;	/* Broadcast packets received */
	WORD tcp_window	__ATTR__;	/* TCP Maximum offered window */
	WORD tcp_mss		__ATTR__;	/* Maximum segment size to be sent with SYN */
	WORD tcp_irtt		__ATTR__;	/* Initial guess at round trip time */
	WORD tcp_retry		__ATTR__;	/* maximum transmission retries */
	WORD tel_tos		__ATTR__;	/* TOS used by Telnet */
	BYTE flush_flag	__ATTR__;	/* To override Nagle */
	WORD tcbs[NTCB]	__ATTR__;	// struct tcb __near *tcbs[NTCB];
	WORD tcp_smss		__ATTR__;	// maximum send segment size
	WORD tcp_time_max	__ATTR__;	// maximum time for retry
	BYTE cAckOnPush	__ATTR__;	// send an ack when push bit is received
};
#endif

typedef struct s_tracebuf {
	WORD 	adr;		// address of allocated buf
	BYTE  id;		// ID of caller
} TRACEBUF;

struct mem_stat {
	DWORD mem_avail	__ATTR__;	/* updated by API_GETVARP call */
	WORD mem_fail		__ATTR__;	/* number of memory alloc failures */
	WORD stack_avail	__ATTR__;	/* lowest stack available observed */
	WORD mem_free_err	__ATTR__;	// memory release errors
	int trace_index	__ATTR__;   // number of entries in trace buffer
	TRACEBUF D_FAR *pwTraceBuf __ATTR__; // pointer to trace buffer
	WORD pFreeChain 	__ATTR__;	// pointer to free chain base
	WORD wLargest	 	__ATTR__;	// largest free block
};

/* Line printer client */
typedef struct {		/* line printer client control block */
	ISOCKET fsocket __ATTR__;
	TIMER timer		__ATTR__;
	WORD tcb			__ATTR__;		// struct tcb __near *tcb;
	WORD buf			__ATTR__;		// void __near *buf;
	BYTE status		__ATTR__;
} LPCB;

typedef struct {
	WORD 	ip_stats		__ATTR__;	// struct ip_stats __near *ipstat;
	WORD	tcp_stat		__ATTR__;	// struct tcp_stat __near *tcpstat;
	WORD	memstat		__ATTR__;	// struct mem_stat __near *memstat;
	WORD	lpcb			__ATTR__;	// LPCB __near *lpcb;
	WORD	ndesc			__ATTR__;	// void __near *ndesc;
	WORD	gdesc			__ATTR__;	// void __near *gdesc;
	short nndesc		__ATTR__;	// number of network descriptors (local)
	short ngdesc		__ATTR__;	// number of global network descriptors
	DWORD http_addr	__ATTR__;	// HTTP server address (set by BOOTP/DHCP)
} VARBLOCK;

/* TCP port numbers */
#define	ECHO_PORT		7				/* Echo data port */
#define	DISCARD_PORT	9				/* Discard data port */
#define	FTPD_PORT		20				/* FTP Data port */
#define	FTP_PORT			21				/* FTP Control port */
#define 	TELNET_PORT		23				/* Telnet port */
#define 	SMTP_PORT		25				/* Mail port */

typedef struct {							/* UDP write parameter block */
	DWORD	dwRemIPAd		__ATTR__;	/* remote IP address */
	WORD	wRemPort			__ATTR__;	/* remote port */
	WORD	wLength			__ATTR__;	/* data count */
	char 	D_FAR *lpBuf	__ATTR__;	/* data buffer address */
} UDP_WR_P;

#ifndef TCB_DEF
#define TCB_DEF
typedef struct tcb {	/* TCP Control Block */
	WORD	prev			__ATTR__;		// struct tcb __near *prev;
	WORD	next			__ATTR__;		// struct tcb __near *next;

	CONNECTION conn	__ATTR__;

	BYTE 	state			__ATTR__;		/* Connection state */
#define	CLOSED			0
#define	LISTEN			1
#define	SYN_SENT			2
#define	SYN_RECEIVED	3
#define	ESTABLISHED		4
#define	FINWAIT1			5
#define	FINWAIT2			6
#define	CLOSE_WAIT		7
#define	CLOSING			8
#define	LAST_ACK			9
#define	TIME_WAIT		10

	BYTE	reason		__ATTR__;	/* Reason for closing */
#define	R_NORMAL		0				/* Normal close */
#define	R_RESET		1				/* Reset by other end */
#define	R_TIMEOUT	2				/* Excessive retransmissions */
#define	R_NETWORK	3				/* Network problem (ICMP message) */

	/* If reason == NETWORK, the ICMP type and code values are stored here */
	char 	type			__ATTR__;
	char 	code			__ATTR__;

	/* Send sequence variables */
	struct {
		long una			__ATTR__;	/* First unacknowledged sequence number */
		long nxt			__ATTR__;	/* Next sequence num to be sent for the first time */
		long ptr			__ATTR__;	/* Working transmission pointer */
		WORD wnd			__ATTR__;	/* Other end's offered receive window */
		long up			__ATTR__;	/* Send urgent pointer */
		long wl1			__ATTR__;	/* Sequence number used for last window update */
		long wl2			__ATTR__;	/* Ack number used for last window update */
	} snd					__ATTR__;
	long iss				__ATTR__;	/* Initial send sequence number */
	WORD cwind			__ATTR__;	/* Congestion window */
	WORD ssthresh		__ATTR__;	/* Slow-start threshold */
	long resent			__ATTR__;	/* Count of bytes retransmitted */

	/* Receive sequence variables */
	struct {
		long nxt			__ATTR__;	/* Incoming sequence number expected next */
		WORD wnd			__ATTR__;	/* Our offered receive window */
		long up			__ATTR__;	/* Receive urgent pointer */
	} rcv					__ATTR__;
	long irs				__ATTR__;	/* Initial receive sequence number */
	WORD mss				__ATTR__;	/* Maximum segment size */
	long rerecv			__ATTR__;	/* Count of duplicate bytes received */

	WORD window			__ATTR__;	/* Receiver window and send queue limit */

	char backoff		__ATTR__;	/* Backoff interval */
	char retry			__ATTR__;	/* retry count */
	void (D_FAR *r_upcall)()	__ATTR__;	/* Call when "significant" amount of data arrives */
	void (D_FAR *t_upcall)()	__ATTR__;	/* Call when ok to send more data */
	void (D_FAR *s_upcall)()	__ATTR__;	/* Call when connection state changes */
	char flags			__ATTR__;	/* Control flags */
#define	FORCE			1				/* We owe the other end an ACK or window update */
#define	CLONE			2				/* Server-type TCB, cloned on incoming SYN */
#define	RETRAN		4				/* A retransmission has occurred */
#define	TCP_RCV		8				/* Set on data arrival, reset by user */
#define	TCP_XMT		0x10			/* Set when ok to send more, reset by user */
#define	TCP_STC		0x20			/* Set on state change, reset by user */
#define	SEND_URG	0x40				/* Set when sending urgent data */
#define	RECV_URG	0x80				/* Set when receiving urgent data */
	char tos				__ATTR__;	/* Type of service (for IP) */

	WORD	rcvq			__ATTR__;	// void __near *rcvq;	/* Receive queue */
	WORD 	rcvcnt		__ATTR__;

	WORD	sndq			__ATTR__;	// void __near *sndq;	/* Send queue */
	WORD	sndcnt		__ATTR__;	/* Number of unacknowledged sequence numbers on
				 * send queue. NB: includes SYN and FIN, which don't
				 * actually appear on sndq!
				 */


	WORD	reseq			__ATTR__;	// void __near *reseq;	/* Out-of-order segment queue */
	TIMER timer			__ATTR__;	/* Retransmission timer */
	TIMER rtt_timer	__ATTR__;	/* Round trip timer */
	long rttseq			__ATTR__;	/* Sequence number being timed */
	long srtt			__ATTR__;	/* Smoothed round trip time, milliseconds */
	long mdev			__ATTR__;	/* Mean deviation, milliseconds */

	WORD	user			__ATTR__;	/* void __near *user;	// User parameter (e.g., for mapping to an
				 * application control block
				 */
	TIMER	ack_timer	__ATTR__;	// Ack timer
	WORD rcv_wndav		__ATTR__;	// Our real available receive window
	WORD mss_rcv		__ATTR__;	// MSS for receiving

	WORD cnt_to_urg	__ATTR__;	// count to urgent data
	WORD urg_cnt		__ATTR__;	// count of urgent data
	char flags1			__ATTR__;	// some more flags
#define F1_LISTEN0		1			// was listening on 0.0.0.0:0
#define F1_KEEPALIVE		2			// keep alive is active
#define F1_KATIMING		4			// keep alive timer running
#define F1_MUSTACK		8			// Ack is outstanding
#define F1_MAXSEGRCVD	0x10		// Max segment has been received
	BYTE num_nacc		__ATTR__;	// Number of not accepted connections
	BYTE max_nacc		__ATTR__;	// Maximum number not accepted connections
	WORD naccq			__ATTR__;		// struct tcb *naccq;	// Not accepted connections queue
} TCB;

#endif

typedef struct {		/* TCP open parameter block */
	DWORD dwRemIPAd	__ATTR__;	/* remote IP address (0 for server) */
	WORD	wRemPort		__ATTR__;	/* remote port (0 for server) */
	WORD	wLocPort		__ATTR__;	/* local port (0 for auto assign, set by kernel) */
	WORD	wMode			__ATTR__;	/* active/passive/server */
	WORD	wWindow		__ATTR__;	/* window size (0 for default) */
	/* data receive upcall handler (0 for none) */
	void (D_FAR *pRcvUpcall)(WORD psTcb,WORD wCnt)	__ATTR__;
	/* data send upcall handler (0 for none) */
	void (D_FAR *pSndUpcall)(WORD psTcb,WORD wCnt)	__ATTR__;
	/* state change upcall handler (0 for none) */
	void (D_FAR *pStcUpcall)(WORD psTcb,char cOldState,char cNewState)	__ATTR__;
	WORD pUser			__ATTR__;	// void __near *pUser;	/* user id field in TCB */
	char cTos			__ATTR__;	/* type of service to use (normally 0) */
} TCP_OP_P;

// Prototypes for API.C interface
// This is work in progress

DWORD GetIPAddress(char *pszName);
int TcpOpen(TCP_OP_P *pOp,WORD *pwHandle);
int TcpRead(WORD wHandle,char *pcBuf,int iLen);
int TcpWrite(WORD wHandle,char *pcBuf,int iLen,int iUrgent);
int TcpClose(WORD wHandle);
int TcpReset(WORD wHandle);
int TcpDelete(WORD wHandle);
char *NetErrStr(int iErrCode);

/* API documentation:
The API is called by calling interrupt API_INT with AH = function code
Other registers are set up and/or returned as detailed below:

SENDPING:
 Entry:
	AH:	API_SENDPING
	BX:	Sequence number
	CX,DX:	IP address
 Exit:
	No change

GETPING:
 Entry:
	AH:	API_GETPING
 Exit:
	AH:	== 0 -> no response
		!= 0 -> valid response
	BX:	Sequence number
	CX,DX:	IP address

STARTMAIL:
 Entry:
	AH:	API_STARTMAIL
 Exit:
	No change

GETIPADR:
 Entry:
	AH:	API_GETIPADR
	BX:CX:	Pointer to name
	If BX:CX == 0:0 then return local IP address and hostname
 Exit:
	CX,DX:	IP address (0 if not found)
	BX:SI:	Pointer to hostname (if BX:CX == 0:0)

TCPOPEN:		open a TCP connection
 Entry:
	AH:	API_TCPOPEN
	BX:CX:	Parameters address, SEG:OFF
 Exit:
	BX:CX:	TCB address, SEG:OFF default INET
	CX:BX:	TCB address, SEG:OFF Large Inet (BX == 4)
	AX:	Error

TCPREAD:		read from a TCP connection
 Entry:
	AH:	API_TCPREAD
	BX:	TCB address
	CX:	Count
	DX:SI	Buffer address (SEG:OFF)
 Exit:
	CX:	Actual read count
	AX:	Error

TCPWRITE:		write to a TCP connection
 Entry:
	AH:	API_TCPWRITE
	AL:	1 for urgent data
	BX:	TCB address
	CX:	Count
	DX:SI	Buffer address (SEG:OFF)

 Exit:
	CX:	Actual write count
	AX:	Error

TCPCLOSE:		close a TCP connection
TCPRESET:		reset a TCP connection
TCPDELET:		delete TCP connection resources
 Entry:
	AH:	API_TCPCLOSE, API_TCPRESET or API_TCPDELET
	BX:	TCB address

 Exit:
	AX:	Error

UDPOPEN:		open a udp socket to receive dg's
 Entry:
	AH:	API_UDPOPEN
	BX:	Local port number
	CX:DX:	Receive upcall address	(0000:0000 for none)
 Exit:
	AX:	Error

UDPREAD:		read a udp datagram
 Entry:
	AH:	API_UDPREAD
	BX:	Local port number
	CX:	Max count
	DX:SI	Buffer address (SEG:OFF)
 Exit:
	AX:	Error
	CX:	Actual read count
	BX:	Remote socket
	DX,SI:	Remote IP address

UDPWRITE:		write a udp datagram
 Entry:
	AH:	API_UDPWRITE
	BX:	Local port number
	DX:SI	Parameter address (SEG:OFF) (UDP_WR_P)
 Exit:
	AX:	Error

UDPCLOSE:		close a udp socket
 Entry:
	AH:	API_UDPCLOSE
	BX:	Local port number
 Exit:
	AX:	Error

GETVARPTR:		get pointer to variables
 Entry:
	AH:	API_GETVARPTR
 Exit:
	BX:CX:	variable block address, SEG:OFF (VARBLOCK)

GETKEY:			get a key from INET
 Entry:
	AH:	API_GETKEY
 Exit:
	AX:	key scancode or -1 if none
	BX:	shift status

FILTER:			modify source route filter to default route
 Entry:
	AH:	API_FILTER
	BX:	FILTER_DISABLE
		FILTER_ENABLE
		FILTER_FLUSH
		FILTER_ADD
	CX,DX	address to add to filter list
 Exit:	0	success
		-1	address already in filter list
		-2	not enough memory to add address
		FILTER_DROP
	CX,DX	address to drop from filter list
 Exit:	0	success
		-1	address not in filter list

TIMERCREATE:	create a timer
 Entry:
	AH:		API_TIMERCREATE
	BX:     Argument to pass to callback funtion
	CX:DX  	Timer period in milliseconds
	SI:DI	Callback address, SEG:OFF
 Exit:
	BX:CX:	Timer address, SEG:OFF
	AX:		Error code: 0 OK, NO_SPACE if out of memory

TIMERSET:		set a timer
 Entry:
	AH:		API_TIMERSET
	BX:		Timer address offset
	CX:DX	Timer period in milliseconds
 Exit:
	AX:		Error code: 0 OK

TIMERSTART		start a timer
 Entry:
	AH:		API_TIMERSTART
	BX:		Timer address offset
 Exit:
	AX:		Error code: 0 OK

TIMERSTOP		stop a timer
 Entry:
	AH:		API_TIMERSTOP
	BX:		Timer address offset
 Exit:
	AX:		Error code: 0 OK

TIMERDELETE		delete a timer, free memory used by timer
 Entry:
	AH:		API_TIMERDELETE
	BX:		Timer address offset
 Exit:
	AX:		Error code: 0 OK


							 TCP Connection State Diagram

										+---------+ ---------\      active OPEN
										|  CLOSED |            \    -----------
										+---------+<---------\   \   create TCB
										  |     ^              \   \  snd SYN
						 passive OPEN |     |   CLOSE        \   \
						 ------------ |     | ----------       \   \
						  create TCB  |     | delete TCB         \   \
										  V     |                      \   \
										+---------+            CLOSE    |    \
										|  LISTEN |          ---------- |     |
										+---------+          delete TCB |     |
						 rcv SYN      |     |     SEND              |     |
						-----------   |     |    -------            |     V
 +---------+      snd SYN,ACK  /       \   snd SYN          +---------+
 |         |<-----------------           ------------------>|         |
 |   SYN_  |                    rcv SYN                     |   SYN_  |
 |RECEIVED |<-----------------------------------------------|   SENT  |
 |         |                    snd ACK                     |         |
 |         |------------------           -------------------|         |
 +---------+   rcv ACK of SYN  \       /  rcv SYN,ACK       +---------+
	|           --------------   |     |   -----------
	|                  x         |     |     snd ACK
	|                            V     V
	|  CLOSE                 +-------------+
	| -------                | ESTABLISHED |
	| snd FIN                +-------------+
	|                   CLOSE    |     |    rcv FIN
	V                  -------   |     |    -------
 +---------+          snd FIN  /       \   snd ACK          +---------+
 |FINWAIT1 |<-----------------           ------------------>| CLOSE_  |
 |         |------------------                              |  WAIT   |
 +---------+          rcv FIN  \                            +---------+
	| rcv ACK of FIN   -------   |                            CLOSE  |
	| --------------   snd ACK   |                           ------- |
	V        x                   V                           snd FIN V
 +---------+                  +---------+                   +---------+
 |FINWAIT2 |                  | CLOSING |                   | LAST_ACK|
 +---------+                  +---------+                   +---------+
	|                rcv ACK of FIN |                 rcv ACK of FIN |
	|  rcv FIN       -------------- |    Timeout=2MSL -------------- |
	|  -------              x       V    ------------        x       V
	 \ snd ACK                 +---------+ delete TCB        +---------+
	  ------------------------>|TIME_WAIT|------------------>| CLOSED  |
										+---------+                   +---------+
*/
