//  $Id: FTPAPI.H 1.6 2003/05/27 19:58:48 johnb Exp $
//
//  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//  Copyright (c) 1999-2003 Datalight, Inc.
//  All Rights Reserved
//
//  Datalight, Inc. is a Washington corporation located at:
//
//  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
//  Bothell, WA  98021                    Fax: +1.425.951.8094
//  USA                                   Http://www.datalight.com
//
//  This software, including without limitation all source code and
//  documentation, is the confidential, trade secret property of
//  Datalight, Inc., and is protected under the copyright laws of
//  the United States and other jurisdictions.  Portions of the
//  software may also be subject to one or more the following US
//  patents: US#5860082, US#6260156.
//
//  In addition to civil penalties for infringement of copyright
//  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//  penalties for violation of (a) the restrictions on circumvention
//  of copyright protection systems found in 17 U.S.C. 1201 and
//  (b) the protections for the integrity of copyright management
//  information found in 17 U.S.C. 1202.
//
//  U.S. Government Restricted Rights.  Use, duplication,
//  reproduction, or transfer of this commercial product and
//  accompanying documentation is restricted in accordance with
//  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
//  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
//  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//  THIS SOFTWARE IN ERROR.
//
/*
	FTPAPI.H
	Copyright (c) 2001 Datalight, Inc.
	All Rights Reserved
	Datalight Confidential and Proprietary
	Portions copyright (c) GPvNO 1999-2001

	Resident FTP API definitions

	Revision History:
	04/23/2003 gvn added sending/receiving status
	06/27/2001 gvn added function number to change the FTP connect port.
*/

#define FTP_INT		0x62

#define OpenFTPSession		0	// par1=server, par2=user, par3=password
										// session id returned in par5,par6
#define CloseFTPSession		1  // par5,par6 = session id
#define SendFTPCommmand		2	// par1=command; par5,par6 = session id
#define GetFTPFile			3	// par1=remote name, par2=local name
										// par5,par6 = session id
#define GetFTPDirectory		4	// par1=file spec, par2=name of file to receive listing
										// par4=1 for long listing, par5,par6 = session id
#define SendFTPFile			5	// par1=local name, par2=remote name,par4=1 for append
										// par5,par6 = session id
#define CheckFTPStatus		6	// par1=buffer for returned string
										// session id returned in par5,par6
#define CallResident			7	// command in AL:

#define XSF_STOP_LISTEN		1
#define XSF_STATUS			2
#define	XSF_UNLOAD			4

#define SetFTPType			8	// par4=1 for Binary (Image), par4=0 for ASCII
										// par5,par6 = session id
#define SetFTPPort			9	// par4=port to use for next OpenFTPSession

#define SetPassiveMode     10 // Par4=0 for non-passive, Par4=1 passive,
										// par5,par6 = session id

// FTP parameter block. A pointer to this block is passed in BX,CX

typedef struct ftppar {
	char far *par1;
	char far *par2;
	char far *par3;
	int par4;
	int par5;
	int	par6;
} FTPPar;

// status return codes returned by CheckFTPStatus

#define	FSTAT_TX_ERR			1	// error sending file
#define 	FSTAT_RX_ERR			2	// error receiving file
#define	FSTAT_TX_OK				3	// file sent OK
#define	FSTAT_RX_OK				4	// file received OK
#define 	FSTAT_LINE_RECEIVED	5	// FTP command line received
#define	FSTAT_SENDING			8	// Sending data
#define	FSTAT_RECEIVING		16	// Receiving data
#define	FSTAT_SENDINGRECVING	(FSTAT_SENDING | FSTAT_RECEIVING)

// error codes returned by other calls

#define	FERR_UNKNOWN_CALL		20	// Unknown API call
#define	FERR_SESSION_OPEN		21
#define 	FERR_SESSION_CLOSED	22
#define	FERR_UNKNOWN_HOST		23
#define 	FERR_NO_MEMORY			24
#define	FERR_TRANSFERRING		25
#define	FERR_PARAMETER_ERROR	26
#define	FERR_FILE_OPEN			27
#define 	FERR_DIR_LIST			28
#define 	FERR_CANT_CREATE		29

