//
//   $Id: ECHO.C 1.5 2002/10/16 16:57:00 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:ECHO.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	CGI extension program that echos users particulars back to him,
	nicely formatted, together with system time and hit count since started

	WARNING: This sample has only been tested with the Borland C compiler and may
	need modification if another compiler is used.

	$DOCHISTORY:

   11/02/2001  jmb added check for additional data and to return
                   to wait for more data if data is not available.
	2001-07-14  gvn fixed resident sizes
	2001-05-11	gvn cleanup
	2000-05-18	jvn first version
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <time.h>
#include <ctype.h>
#include <process.h>
#include "cgiadap.h"

//Make the heap and stack smaller as not to waste memory when going resident
//_stklen should be greater than GetStackPointer() (defualt 1000) for the sake of callbacks
extern unsigned _stklen = 3000;
extern unsigned _heaplen = 1000;

void GoDOS(void);


/*
 * Parse query, alloc string contaning response, typecast as long and return
 */
static int iHitcount = 0;
static char *szResponse =
	"HTTP/1.0 200 OK\r\n\r\n"
	"<HTML><TITLE>Welcome %s!</TITLE><BODY bgcolor=green>"
	"<FONT color=blue>"
	"<H1 align=center>A warm welcome to %s!</H1>"
	"<FONT size=5 color=yellow>"
	"<P align=center>"
	"Your call was received at %s"
	"<BR>You are user number <U>%d</U> to call"
	"<BR>Your password is <I>%s</I>"
	"<BR>Your number is <B>%s</B>"
	"<BR><BR>Goodbye!"
	"</P></BODY></HTML>";

void DoResponse(int iHandle, char *szQuery)
{
	char *pName, *pPass, *pNo, *pTerm;
	char szString[400];
	int iSize;
	time_t tNow = time(0);

	//parse string

	//pName = pAddr = pNo = "123";
	pName = strstr(szQuery, "name=") + 5;
	pPass = strstr(szQuery, "pass=") + 5;
	pNo = strstr(szQuery, "number=") + 7;
	pTerm = szQuery;
	while ((pTerm = strchr(pTerm, '&')) != 0)
		*pTerm++ = 0;

	//test username and password for validity

	//test number for validity
	pTerm = pNo;
	while (*pTerm != 0 && isdigit(*pTerm))
		pTerm++;
	if (*pTerm != 0 || pNo == pTerm)	//invalid number
		pNo = "INVALID";
	if (*pName == 0)
		pName = "~Unknown~";
	if (*pPass == 0)
		pPass = "not supplied";

	iSize = sprintf(szString, szResponse, pName, pName, ctime(&tNow),
		iHitcount++, pPass, pNo);

	HttpSendData(iHandle, szString, iSize);
}

int far Callback(HTTP_PARAMS far* psParams)
{
	char arReadbuf[200];
	int iRet;


	iRet = HttpGetData(psParams->iHandle, arReadbuf, 200);
	if (iRet < 0)
   {
      if (iRet == -WOULDBLK)
         return RET_OK;
      else
   		return RET_ERR;
   }


#if 0

11/06/2001 jmb this code could be dangerous.  If all of the data is not
               present, should we wait or give an error?  If all of the
 					data has not been delivered then the code below will catch
					erroneous data.

   // all of the expected data read?
   if (iRet < psParams->lContentLen)
      // no, wait for it all.
      return RET_OK;

#endif

	arReadbuf[iRet] = 0;
	DoResponse(psParams->iHandle, arReadbuf);
	return RET_DONE;
}

void main(int iArgc, char *pArgs[])
{
	if(HttpRegister("echo.htm", Callback, F_OVERLAP, 0) != NONE) {
		HttpDeRegister("echo.htm");
		printf("cannot register\n");
		exit(-1);
	}

	if (iArgc > 1 && strcmp(pArgs[1], "/t") == 0)
		GoDOS();
	else {
		/*
			PLEASE NOTE: take care when calculating the amount of memory to save
				as different memory models use different memory layouts
		 */
		int iSize = _SS - _psp + (_SP - 1000) / 16 + 1;
		printf("Resident program at %04x, Callback stack at %04x:%04x\n"
				 "Size = %u bytes, 0x%x paragraphs\n",_psp,
				 GetStackSegment(),GetStackPointer(),iSize * 16, iSize);
		keep(0, iSize);//go tsr
	}


	printf("Program exiting\n");
	HttpDeRegister("echo.htm");
}
void GoDOS(void)
{
	char *argvl[2];

	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	printf("Type 'exit' to unload program\n");
	spawnvp(P_WAIT,argvl[0],argvl);
}

