//
//   $Id: ffur.c 1.4 2002/10/16 16:57:00 peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	FFUR.C

	Copyright 2001 (c) Datalight, Inc.
	All Rights Reserved
	Datalight Confidential and Proprietary
	Portions Copyright GPvNO (c) 2001

	Form-based File Upload Receiver (FFUR) in HTML for CGI

	PLEASE NOTE:
	This is only a very basic and specific example of how file uploads may be done
	using a cgi extension. This is in no means a general MIME multipart parser.
	It will only work with a very specific form: ffur.htm.

	WARNING: This sample has only been tested with the Borland C compiler and may
	need modification if another compiler is used.

	RFC 1867
	GV van Niekerk
	gerrit@osi.co.za

	REVISION HISTORY
	07/14/2001 make resident by spawning COMMAND.COM
	05/10/2001 added "back" link
*/

/*
accepted format:
--boundary
content-disposition: <comma or semicolon seperated entities> filename=["]filename["] ...
<other headers>
<empty line>
<.....file to be saved........><newline>
--boundary--
*/

#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <process.h>
#include "cgiadap.h"

#define BUF_SIZE		4096

// Make the heap and stack smaller so as not to waste memory when going resident
// _stklen should be at least 1000 + the stack required for the callback

extern unsigned _stklen = 8000;
extern unsigned _heaplen = 2000;
unsigned int _nfile = 20;

//prototypes
static char *findTokenValue(char *szLine, char *szTokenName);
int far Callback(HTTP_PARAMS far *pPars);

#define LINELEN	100
typedef struct
{
	char inFile;
	FILE *pfFile;
	char rgLine[LINELEN];
	int iIndex;
	char rgBoundary[LINELEN];
	int iBoundaryIndex;
	int iBoundarySize;
	long lFilesize;
	char rgFilename[LINELEN];
} VARS;

void main(void)
{
	char *argvl[2];

	if(HttpRegister("ffurcgi.htm", Callback, F_OVERLAP, 0) != NONE) {
		printf("Error: cannot register ffurcgi.htm\n");
		HttpDeRegister("ffurcgi.htm");
		exit(-1);
	}
	if ((argvl[0] = getenv("COMSPEC")) == 0)
		argvl[0] = "\\COMMAND.COM";
	argvl[1] = 0;
	printf("Type 'exit' to unload FFUR\n");
	spawnvp(P_WAIT,argvl[0],argvl);
	printf("FFUR unloaded\n");
	HttpDeRegister("ffurcgi.htm");
}

//Send the specified reponse to the client
static void SendResponse(VARS *pVars, int iHandle, char* pszResponse)
{
	static char pszHeader[] = "HTTP/1.0 200 OK\r\n\r\n";
	static char pszBack[]="<P><P><html><A HREF=\"/ffur.htm\">Back.</A></html>\n";

	HttpSendData(iHandle, pszHeader, strlen(pszHeader));
	HttpSendData(iHandle, pszResponse, strlen(pszResponse));
	HttpSendData(iHandle, pszBack, strlen(pszBack));

	if (pVars) {
		if (pVars->pfFile) {
			fclose (pVars->pfFile);
			pVars->pfFile = 0;
		}
		free (pVars);
	}
}

/*
called by http server on cgi request
*/
int far Callback(HTTP_PARAMS far *pPars)
{
	char rgcReadBuf[BUF_SIZE + 1];
	int iRet;
	int iPos;
	VARS *pVars = (VARS *)pPars->dwSessionID;
	static char szResp[100];

	if (pPars->iReason != R_INDATA) //not interested in anything else
		return RET_OK;

	if (!pVars) {
		if ((pVars = calloc(1, sizeof(VARS))) == 0)
			return RET_ERR;
		pPars->dwSessionID = (long)pVars;
	}

	if (pPars->iValue > BUF_SIZE)
		pPars->iValue = BUF_SIZE;
	iRet = HttpGetData(pPars->iHandle, rgcReadBuf, pPars->iValue);
	//rgcReadBuf[iRet] = 0;
	//printf("Got %d bytes: readcall = %d\n", iRet, pPars->iValue);
	//if (pVars)	return RET_OK;//NB debug
	if (iRet < 0) {
		if (iRet == -WOULDBLK)
			return RET_OK;
		//printf("Got - error: done\n");
		sprintf(szResp, "Error %d reading", iRet);

		SendResponse(pVars, pPars->iHandle, szResp);
		return RET_ERR;
	}
	if (iRet == 0) {
		//printf("Got 0: done\n");
		SendResponse(pVars, pPars->iHandle, "Finished reading: illegal MIME format");
		return RET_DONE;
	}
	for (iPos = 0; iPos < iRet; iPos++) {
		char c = rgcReadBuf[iPos];

		if (!pVars->inFile) {
			if (c == '\r')		//just ignore
				continue;
			if (c != '\n') {
				if (pVars->iIndex < LINELEN)
					pVars->rgLine[pVars->iIndex++] = c;
				continue;
			}

			//handle header
			if (!pVars->iIndex) //empty line, end of header
				pVars->inFile = 1;

			pVars->rgLine[pVars->iIndex] = 0;
			pVars->iIndex = 0;

			if (memcmp(pVars->rgLine, "--", 2) == 0) {
				//boundary, use as end boundary
				pVars->iBoundarySize =
				 sprintf(pVars->rgBoundary, "\r\n%s", pVars->rgLine);
				//printf("Got first boundary:%s\n", szBoundary);
			}
			else if (strnicmp(pVars->rgLine, "content-disposition", 18) == 0) {
				char *p = findTokenValue(pVars->rgLine, "filename");
				if (p == 0)
					p = findTokenValue(pVars->rgLine, "name");
				if (p != 0)
					pVars->pfFile = fopen(p, "wb");
				if (!pVars->pfFile) {
					SendResponse(pVars, pPars->iHandle, "Cant open file");
					return RET_ERR;
				}
				strcpy(pVars->rgFilename, p);
			}
			continue;
		}
		//look for end boundary
		if (pVars->rgBoundary[pVars->iBoundaryIndex] == c) {
			pVars->iBoundaryIndex++;
			if (pVars->iBoundaryIndex == pVars->iBoundarySize) {
				sprintf(szResp, "File: %s Received %ld bytes OK",
				 pVars->rgFilename, pVars->lFilesize);
				//done
				SendResponse(pVars, pPars->iHandle, szResp);//close everything
				//printf("Really done\n");
				return RET_DONE;
			}
			continue;
		}
		else {
			//didnt match - recycle chars
			if (fwrite(pVars->rgBoundary, 1, pVars->iBoundaryIndex,
			 pVars->pfFile) != pVars->iBoundaryIndex) {
				SendResponse(pVars, pPars->iHandle, "Cant write to specified file");
				return RET_ERR;
			}
			pVars->lFilesize += pVars->iBoundaryIndex;
			pVars->iBoundaryIndex = 0;
			if (c == pVars->rgBoundary[0]) {
				pVars->iBoundaryIndex++;
				continue;
			}
		}
		pVars->lFilesize++;
		if (fputc(c, pVars->pfFile) == EOF) {
			SendResponse(pVars, pPars->iHandle, "Cant write to specified file");
			return RET_ERR;
		}
	}

	return RET_OK;
}

/*
Find the filename somewhere in the arguments of a 0-terminated string.
Returns a pointer to the start of the file name.
Also, terminate the filename with a 0.
*/
static char *findTokenValue(char *szLine, char *szTokenName)
{
	char *pEnd;
	char *szTerminators = "= \t";

	while (1) {
		szLine = strstr(szLine, szTokenName);
		if (szLine == 0)
			break;
		//test if this isn't part of something longer like 'xxszTokenName'
		if (!isalpha(*(szLine - 1))) {
			//this is the real thing, save
			szLine += strlen(szTokenName);
			while (strchr(szTerminators, *szLine) != 0) //skip seprators like =
				szLine++;
			if (*szLine == 0)	//string has died on us
				return 0;
			if (*szLine == '"') {//quoted filename
				szLine++;//move past quote
				szTerminators = "\"\r\n\0";
			}
			else
				szTerminators = ",; \"\t\r\n\0";
			pEnd = szLine;	//points to start of file name
			while (strchr(szTerminators, *pEnd) == 0) {
				if (strchr("\\/", *pEnd) != 0)
					szLine = pEnd + 1;       	//move past last /
				pEnd++;
			}
			*pEnd = 0;
			return szLine;
		}
		szLine++;
	}
	return 0;
}

